package solutions.bitbadger.documents.groovy.jvm.integration.sqlite

import org.junit.jupiter.api.DisplayName
import org.junit.jupiter.api.Test
import solutions.bitbadger.documents.groovy.jvm.integration.common.CustomFunctions
import solutions.bitbadger.documents.jvm.integration.sqlite.SQLiteDB

/**
 * SQLite integration tests for the `Custom` object / `custom*` connection extension functions
 */
@DisplayName("JVM | Groovy | SQLite: Custom")
class CustomIT {

    @Test
    @DisplayName("list succeeds with empty list")
    void listEmpty() {
        new SQLiteDB().withCloseable(CustomFunctions.&listEmpty)
    }

    @Test
    @DisplayName("list succeeds with a non-empty list")
    void listAll() {
        new SQLiteDB().withCloseable(CustomFunctions.&listAll)
    }

    @Test
    @DisplayName("single succeeds when document not found")
    void singleNone() {
        new SQLiteDB().withCloseable(CustomFunctions.&singleNone)
    }

    @Test
    @DisplayName("single succeeds when a document is found")
    void singleOne() {
        new SQLiteDB().withCloseable(CustomFunctions.&singleOne)
    }

    @Test
    @DisplayName("nonQuery makes changes")
    void nonQueryChanges() {
        new SQLiteDB().withCloseable(CustomFunctions.&nonQueryChanges)
    }

    @Test
    @DisplayName("nonQuery makes no changes when where clause matches nothing")
    void nonQueryNoChanges() {
        new SQLiteDB().withCloseable(CustomFunctions.&nonQueryNoChanges)
    }

    @Test
    @DisplayName("scalar succeeds")
    void scalar() {
        new SQLiteDB().withCloseable(CustomFunctions.&scalar)
    }
}
