package solutions.bitbadger.documents.groovy.support

import solutions.bitbadger.documents.jvm.Document
import solutions.bitbadger.documents.support.ThrowawayDatabase

import static solutions.bitbadger.documents.support.TypesKt.TEST_TABLE

class JsonDocument {
    String id
    String value
    int numValue
    SubDocument sub

    JsonDocument(String id = null, String value = "", int numValue = 0, SubDocument sub = null) {
        this.id = id
        this.value = value
        this.numValue = numValue
        this.sub = sub
    }

    private static final List<JsonDocument> testDocuments = List.of(
            new JsonDocument("one", "FIRST!", 0),
            new JsonDocument("two", "another", 10, new SubDocument("green", "blue")),
            new JsonDocument("three", "", 4),
            new JsonDocument("four", "purple", 17, new SubDocument("green", "red")),
            new JsonDocument("five", "purple", 18))

    static void load(ThrowawayDatabase db, String tableName = TEST_TABLE) {
        testDocuments.forEach { Document.insert(tableName, it, db.conn) }
    }
}
