package solutions.bitbadger.documents.java.jvm.integration.sqlite;

import org.junit.jupiter.api.DisplayName;
import org.junit.jupiter.api.Test;
import solutions.bitbadger.documents.DocumentException;
import solutions.bitbadger.documents.java.jvm.integration.common.CustomFunctions;
import solutions.bitbadger.documents.jvm.integration.sqlite.SQLiteDB;

/**
 * SQLite integration tests for the `Custom` object / `custom*` connection extension functions
 */
@DisplayName("JVM | Java | SQLite: Custom")
final public class CustomIT {

    @Test
    @DisplayName("list succeeds with empty list")
    public void listEmpty() throws DocumentException {
        try (SQLiteDB db = new SQLiteDB()) {
            CustomFunctions.listEmpty(db);
        }
    }

    @Test
    @DisplayName("list succeeds with a non-empty list")
    public void listAll() throws DocumentException {
        try (SQLiteDB db = new SQLiteDB()) {
            CustomFunctions.listAll(db);
        }
    }

    @Test
    @DisplayName("single succeeds when document not found")
    public void singleNone() throws DocumentException {
        try (SQLiteDB db = new SQLiteDB()) {
            CustomFunctions.singleNone(db);
        }
    }

    @Test
    @DisplayName("single succeeds when a document is found")
    public void singleOne() throws DocumentException {
        try (SQLiteDB db = new SQLiteDB()) {
            CustomFunctions.singleOne(db);
        }
    }

    @Test
    @DisplayName("nonQuery makes changes")
    public void nonQueryChanges() throws DocumentException {
        try (SQLiteDB db = new SQLiteDB()) {
            CustomFunctions.nonQueryChanges(db);
        }
    }

    @Test
    @DisplayName("nonQuery makes no changes when where clause matches nothing")
    public void nonQueryNoChanges() throws DocumentException {
        try (SQLiteDB db = new SQLiteDB()) {
            CustomFunctions.nonQueryNoChanges(db);
        }
    }

    @Test
    @DisplayName("scalar succeeds")
    public void scalar() throws DocumentException {
        try (SQLiteDB db = new SQLiteDB()) {
            CustomFunctions.scalar(db);
        }
    }
}
