package solutions.bitbadger.documents.scala.jvm.integration.sqlite

import org.junit.jupiter.api.{DisplayName, Test}
import solutions.bitbadger.documents.jvm.integration.sqlite.SQLiteDB
import solutions.bitbadger.documents.scala.jvm.integration.common.CountFunctions
import org.junit.jupiter.api.Assertions.assertThrows
import solutions.bitbadger.documents.DocumentException

import scala.util.Using

@DisplayName("JVM | Scala | SQLite: Count")
class CountIT {

  @Test
  @DisplayName("all counts all documents")
  def all(): Unit =
    Using(SQLiteDB()) { db => CountFunctions.all(db) }

  @Test
  @DisplayName("byFields counts documents by a numeric value")
  def byFieldsNumeric(): Unit =
    Using(SQLiteDB()) { db => CountFunctions.byFieldsNumeric(db) }

  @Test
  @DisplayName("byFields counts documents by a alphanumeric value")
  def byFieldsAlpha(): Unit =
    Using(SQLiteDB()) { db => CountFunctions.byFieldsAlpha(db) }

  @Test
  @DisplayName("byContains fails")
  def byContainsMatch(): Unit =
    Using(SQLiteDB()) { db => assertThrows(classOf[DocumentException], () => CountFunctions.byContainsMatch(db)) }

  @Test
  @DisplayName("byJsonPath fails")
  def byJsonPathMatch(): Unit =
    Using(SQLiteDB()) { db => assertThrows(classOf[DocumentException], () => CountFunctions.byJsonPathMatch(db)) }
}
